# Modul: Editor fr Eigenschaften einer Bedingung bei Schleifen und IF-THENs
# 02.03.2002, 15.10.02
# i.linkweiler@gmx.de

from qt import *
from Statements import *

class ForeditWidget(QWidget):
  "Ein QT-Wudget zum Bearbeiten einer For-Schleife"
  def __init__(self,*args):
    "Erzeuge in Widget"
    apply(QWidget.__init__,(self,) + args)
    self.setMinimumSize(320,120)
    self.resize(320,120)
    
    self.setCaption(_('Schleife Eigenschaften'))
    self.icon=QPixmap("./icons/find.xpm")
    self.setIcon(self.icon)

    self.ok = QPushButton(_("&OK"),self,"ok")
    self.ok.setGeometry(40,90,75,24)
    self.connect(self.ok,SIGNAL("clicked()"),self.slotOk)

    self.abbruch = QPushButton(_("&Abbruch"),self,"abbruch")
    self.abbruch.setGeometry(120,90,75,24)
    self.connect(self.abbruch,SIGNAL("clicked()"),self.close)

    self.hilfe = QPushButton(_("&Hilfe"),self,"hilfe")
    self.hilfe.setGeometry(200,90,75,24)
    self.connect(self.hilfe,SIGNAL("clicked()"),self.slotHilfe)


    self.t1= QLabel(_("Schleifenvariable"),self)
    self.t1.setGeometry(4,20,110,20)
    self.edit = QLineEdit(self)
    self.edit.setGeometry(120,20,200,20)

    self.t2= QLabel(_("Bereich/Elementliste"),self)
    self.t2.setGeometry(4,50,110,20)
    self.edit2 = QLineEdit(self)
    self.edit2.setGeometry(120,50,200,20)

    self.exitcmd=None

  def slotHilfe(self):
    import hilfe
    hilfe.zeigen("./readme/schleife.html")
    

  def setexitcmd(self,cmd):
    " <cmd> kann aufgerufen werden, wenn Dialog mit OK beendet wurde."
    self.exitcmd=cmd

  def setitem(self,item):
    " Setze das zu bearbeitende Objekt."
    self.item=item
    self.edit.setText(item.iterator)
    self.edit2.setText(item.condition)


  def slotOk(self):
    " Da hat wohl jemand OK geklickt."
    s=self.edit2.text()
    t=unicode(s)
    self.item.setCond(t)

    s=self.edit.text()
    t=unicode(s)
    self.item.setIterator(t)


    if self.exitcmd!=None: 
      self.exitcmd()
    self.close(1)

def main():
    "Test-Funktion"
    STYLE="Qt"
    item=Forloop(STYLE)

    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL('lastWindowClosed()'),a,SLOT('quit()'))
    w = ForeditWidget()
    a.setMainWidget(w)
    
    w.setitem(item)
    w.show()
    a.exec_loop()

if __name__=="__main__":
  def _(x): return x
  main()

