"""
Modul: Editor fr Eigenschaften einer Klasse
10.04.2002 
i.linkweiler@gmx.de
"""
from qt import *
from Statements import *

class KlasseneditWidget(QWidget):
  "QT-Widget, Editor fr Eigenschaften einer Klasse"
  def __init__(self,*args):
    "Erzeuge Widget"
    apply(QWidget.__init__,(self,) + args)
    self.setMinimumSize(340,150)
    self.resize(340,150)
    
    self.setCaption('Klasse')
    self.icon=QPixmap("./icons/find.xpm")
    self.setIcon(self.icon)

    self.ok = QPushButton("&OK",self,"ok")
    self.ok.setGeometry(100,120,75,24)
    self.connect(self.ok,SIGNAL("clicked()"),self.slotOk)

    self.abbruch = QPushButton("&Abbruch",self,"abbruch")
    self.abbruch.setGeometry(200,120,75,24)
    self.connect(self.abbruch,SIGNAL("clicked()"),self.close)

    self.t2= QLabel("Name der Klasse:",self)
    self.t2.setGeometry(20,10,300,20)
    self.edit = QLineEdit(self)
    self.edit.setGeometry(20,30,300,20)

    self.exitcmd=None

  def setexitcmd(self,cmd):
    " <cmd> kann aufgerufen werden, wenn Dialog mit OK beendet wurde."
    self.exitcmd=cmd

  def setitem(self,item):
    " Setze das zu bearbeitende Objekt."
    self.item=item
    self.edit.setText(item.text)


  def slotOk(self):
    " Da hat wohl jemand OK geklickt."

    s=self.edit.text()
    t=unicode(s)
    self.item.setText(t)

    if self.exitcmd!=None: 
      self.exitcmd()
    self.close(1)

def main():
    " Zum Test"
    STYLE="Qt"
    item=Function(STYLE)

    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL('lastWindowClosed()'),a,SLOT('quit()'))
    w = KlasseneditWidget()
    a.setMainWidget(w)
    
    w.setitem(item)
    w.show()
    a.exec_loop()

if __name__=="__main__":
  main()

