"""
Modul: Editor fr Eigenschaften einer Bedingung bei Schleifen und IF-THENs
02.03.2002 
i.linkweiler@gmx.de
"""

from qt import *
from Statements import *


    

class PaintView(QWidget):
  "Ein QT-Widget zum Bearbeiten von Anweisungen"
  def __init__(self,*args):
    "Erzeuge das Widget"
    apply(QWidget.__init__,(self,) + args)
    self.setMinimumSize(320,160)
    self.resize(320,160)

    self.setCaption(_('Anweisung bearbeiten'))
    self.icon=QPixmap("./icons/find.xpm")
    self.setIcon(self.icon)

    self.ok = QPushButton(_("&OK"),self,"ok")
    self.ok.setGeometry(40,135,75,24)
    self.connect(self.ok,SIGNAL("clicked()"),self.slotOk)

    # self.pd=QPaintDevice()
    
    self.pm = QPixmap(150,50)
    self.but=QPushButton("Huhu",self,"ebde")
    self.but.setPixmap(self.pm)
    self.but.setGeometry(0,0,100,100)

    #self.pm.begin()
    
    self.painter = QPainter()
    self.painter.begin(self.pm)
    self.painter.setPen(QPen(QColor(0,200,200)))
    self.painter.drawLine(0,0,100,100)
    self.painter.end()

    self.abbruch = QPushButton(_("&Abbruch"),self,"abbruch")
    self.abbruch.setGeometry(120,135,75,24)
    self.connect(self.abbruch,SIGNAL("clicked()"),self.close)

   
  def setexitcmd(self,cmd):
    "<cmd> kann aufgerufen werden, wenn Dialog mit OK beendet wurde."
    self.exitcmd=cmd

  def setitem(self,item):
    "Setze das zu bearbeitende Objekt."
    self.item=item

  def slotOk(self):
    "Da hat wohl jemand OK geklickt."
    if self.exitcmd!=None: 
      self.exitcmd()
    self.close(1)

  def resizeEvent(self,resizeEvent):
    #self.edit.resize(self.width(),self.height() - 16 - 5)
    #self.edit.setGeometry(0,40,self.width()-2,self.height()-40)
    pass

def main():
    "Test-Funktion"
    STYLE="Qt"
    item=Command(STYLE)

    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL('lastWindowClosed()'),a,SLOT('quit()'))
    w = PaintView()
    a.setMainWidget(w)
    
    w.setitem(item)
    w.show()
    a.exec_loop()

if __name__=="__main__":
  def _(x): return x
  main()
